#include "stdafx.h"

using namespace std;

vector::vector(int n)
{
	this->n = n;
	p = new double[n];
	for (int i = 0; i < n; i++) p[i] = 0;
	#ifdef debug
	cout << "vector " << n << " created\n";
	#endif
}


vector::~vector()
{
	#ifdef debug
	cout << "vector " << n << " deleted\n";
	#endif
	// delete p;
}


double & vector::operator[](int i)
{
	if (i >= 0 && i < n) return p[i];
	else throw out_of_range("Vector out of range");
}

void vector::resize(int m)
{
	double *q = new double[m];
	for (int i = 0; i < m; i++) q[i] = 0;
	for (int i = 0; i < ( m < n ? m : n); i++) q[i] = p[i];
	// delete p;
	p = q;
	n = m;
}

void vector::operator=(double x)
{
	for (int i = 0; i < n; i++) p[i] = x;
}


ostream & operator << (ostream & stream, vector  obj)
{
	for (int i = 0; i < obj.N(); i++)
		stream << obj[i] << " ";
	stream << std::endl;

	return stream;
}

